<template>
  <sui-modal
    v-model="visible"
    size="standart"
    :animation-duration="1"
    v-dom-move
    v-scroll-lock="selectBrandsModalShow">
    <i
      class="close icon"
      @click="hideModal"/>
    <div class="header default padding gray">
      <div class="title">Выберите марки авто</div>
    </div>
    <div class="content without padding">
      <div class="tabular menu">
        <div
          @click="toggleTabular(tabs.typesOfCars)"
          class="item"
          :class="{active : activeTab === tabs.typesOfCars}">По типу автомобиля
        </div>
        <div
          @click="toggleTabular(tabs.manufacturersByRegion)"
          class="item"
          :class="{active : activeTab=== tabs.manufacturersByRegion}">По стране
          производства
        </div>
      </div>
      <div class="tab segment">
        <div class="block top">
          <div
            class="ui checkbox">
            <input
              type="checkbox"
              :id="`brands-all + ${type}`"
              name="brands-all"
              :checked="isSelectedAllBrands()"
              @change="selectAllBrands">
            <label
              :for="`brands-all + ${type}`"
              class="medium">
              Выбрать все марки
            </label>
          </div>
        </div>
        <div
          v-if="activeTab === tabs.typesOfCars"
          class="block content">
          <div class="scroll">
            <div
              class="block accordion"
              v-if="typesOfCars.length">
              <div
                v-for="(item, i) in typesOfCars"
                :key="`${type} + ${i}`"
                class="panel"
                :class="{opened : isOpenPanel[i]}">
                <div
                  class="title"
                  @click="toggleAccordion(i)">
                  <div
                    class="icon-car"
                    :class="item.class"/>
                  <span>
                    {{ item.name }}
                  </span>
                  <span
                    class="count"
                    v-if="countSelectedItem(item.items)">
                    ({{ countSelectedItem(item.items) }})
                  </span>

                </div>
                <div class="content">
                  <div class="ui checkbox group">
                    <input
                      type="checkbox"
                      :id="`${type} + ${i}`"
                      :name="`${type} + ${i}`"
                      :checked="isSelectedItemsByType(item.items)"
                      @change="selectAllItemsCurrentType($event, item.items)">
                    <label
                      v-if="item.items.length"
                      :for="`${type} + ${i}`"
                      class="medium">
                      Выбрать все {{ item.items.length }}
                      {{ item.items.length | transChoose(['марку', 'марки', 'марок']) }}
                    </label>
                  </div>
                  <div class="list-checkbox">
                    <div class="group tagged">
                      <div
                        v-for="(brand, j) in item.items"
                        :key="`${type} + ${i} + ${j}`"
                        class="item-checkbox">
                        <div class="ui child checkbox">
                          <input
                            type="checkbox"
                            v-model="brand.checked"
                            :id="`${type} + ${i} + ${j}`">
                          <label :for="`${type} + ${i} + ${j}`">
                            {{ brand.contractModal.name }}
                          </label>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div
          v-if="activeTab === tabs.manufacturersByRegion"
          class="block content">
          <div class="scroll">
            <div class="block accordion">
              <div
                v-for="(region, i) in manufacturersByRegion"
                :key="`${type} + ${i} + region`"
                class="panel"
                :class="{opened : isOpenPanel[i]}">
                <div
                  class="title"
                  @click="toggleAccordion(i)">
                  <div class="kit flag outer round">
                    <span
                      class="kit flag"
                      :class="'flag-' + region.code"/>
                  </div>
                  <span>
                    {{ region.name }}
                  </span>
                  <span
                    class="count"
                    v-if="countSelectedItem(region.items)">
                    ({{ countSelectedItem(region.items) }})
                  </span>
                </div>
                <div class="content">
                  <div class="ui checkbox group">
                    <input
                      type="checkbox"
                      :id="`brands-all- + ${i} + ${type}`"
                      :name="`brands-all- + ${i} + ${type}`"
                      :checked="isSelectedItemsByType(region.items)"
                      @change="selectAllItemsCurrentType($event, region.items)">
                    <label
                      :for="`brands-all- + ${i} + ${type}`"
                      class="medium">
                      Выбрать все {{ region.items.length }}
                      {{ region.items.length | transChoose(['марку', 'марки', 'марок']) }}
                    </label>
                  </div>
                  <div class="list-checkbox">
                    <div class="group tagged">
                      <div
                        v-for="(brand, j) in region.items"
                        :key="`brand- + ${i} + ${j} + ${type}`"
                        class="item-checkbox">
                        <div class="ui child checkbox">
                          <input
                            type="checkbox"
                            v-model="brand.checked"
                            :id="`brand- + ${i} + ${j} + ${type}`">
                          <label :for="`brand- + ${i} + ${j} + ${type}`">
                            {{ brand.contractModal.name }}
                          </label>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="actions without padding ">
      <div class="footer">
        <button
          type="button"
          class="ui button yellow circular inmodal"
          @click="saveChoice">
          Сохранить
        </button>
        <button
          type="button"
          class="ui button transparent inmodal"
          @click="clearAll">
          Очистить все
        </button>
      </div>
    </div>
  </sui-modal>

</template>

<script>
import {
  has,
  uniqBy,
  pickBy,
  map,
} from 'lodash-es';
import CarManufacture from '~/assets/js/model/car-manufacture/car-manufacture';

const TYPES_OF_CARS = 'typesOfCars';
const MANUFACTURERS_BY_REGION = 'manufacturersByRegion';

export default {
  name: 'Brands',
  model: {
    prop: 'selectBrandsModalShow',
    event: 'change',
  },
  props: {
    carManufacturers: {
      type: Object,
      default() {
        return {};
      },
    },
    currentSelectedManufacturers: {
      type: Array,
      default() {
        return [];
      },
    },
    selectBrandsModalShow: {
      type: Boolean,
      required: true,
    },
    type: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      tabs: {
        typesOfCars: TYPES_OF_CARS,
        manufacturersByRegion: MANUFACTURERS_BY_REGION,
      },
      listClass: true,
      activeTab: TYPES_OF_CARS,
      isOpenPanel: {
        type: Array,
        default: false,
      },
      [TYPES_OF_CARS]: this.getTypesOfCars(),
      [MANUFACTURERS_BY_REGION]: this.getManufacturersByRegion(),
    };
  },
  computed: {
    visible: {
      get() {
        return this.selectBrandsModalShow;
      },
      set() {
        this.hideModal();
      },
    },
  },
  methods: {
    hideModal() {
      this.$emit('change', false);
    },
    toggleTabular(tab) {
      this.activeTab = tab;
    },
    toggleAccordion(index) {
      this.$set(this.isOpenPanel, index, !this.isOpenPanel[index]);
    },
    getTypesOfCars() {
      const typesOfCars = [];

      has(this.carManufacturers, 'truck') && typesOfCars.push({
        code: 'truck',
        name: 'Грузовые',
        items: this.getCarManufacturersItem(this.carManufacturers.truck),
      });

      has(this.carManufacturers, 'other') && typesOfCars.push({
        code: 'other',
        name: 'Другие',
        items: this.getCarManufacturersItem(this.carManufacturers.other),
      });

      return typesOfCars;
    },
    getManufacturersByRegion() {
      const noneRegions = ['truck', 'other'];
      const regions = {
        china: 'Китай',
        europe: 'Европа',
        japan: 'Япония',
        russia: 'Россия',
        korea: 'Корея',
        usa: 'США',
      };

      return map(
        pickBy(this.carManufacturers, (item, key) => !noneRegions.some(i => key === i)),
        (item, key) => ({
          code: key,
          name: regions[key],
          items: this.getCarManufacturersItem(item),
        }),
      );
    },
    getCarManufacturersItem(carManufacturers) {
      if (!carManufacturers || !carManufacturers.length) {
        return [];
      }

      return carManufacturers
        .map((carManufacturer) => {
          const item = new CarManufacture(carManufacturer);
          item.checked = this.currentSelectedManufacturers
            .some(currentListService => Number(currentListService.id) === Number(item.contractModal.id));

          return item;
        });
    },
    selectAllBrands(value) {
      if (value && value.target) {
        this[this.activeTab]
          .flatMap(type => type.items)
          .forEach((item) => { item.checked = value.target.checked; });
      }
    },
    isSelectedAllBrands() {
      if (!this[this.activeTab] && !this[this.activeTab].length) {
        return false;
      }

      return this[this.activeTab]
        .flatMap(type => type.items)
        .every(item => item.checked);
    },
    selectAllItemsCurrentType(value, brands) {
      if (value && value.target) {
        brands = brands.forEach((item) => { item.checked = value.target.checked; });
      }
      return brands;
    },
    isSelectedItemsByType(brands) {
      if (!brands && !brands.length) {
        return false;
      }

      return brands.every(brand => brand.checked);
    },
    countSelectedItem(items) {
      if (!items && !items.length) {
        return false;
      }

      return items.filter(brand => brand.checked).length;
    },
    clearAll() {
      this[TYPES_OF_CARS]
        .flatMap(type => type.items)
        .forEach((item) => { item.checked = false; });

      this[MANUFACTURERS_BY_REGION]
        .flatMap(type => type.items)
        .forEach((item) => { item.checked = false; });
    },
    saveChoice() {
      const result = [
        ...this[TYPES_OF_CARS]
          .flatMap(type => type.items)
          .filter(item => item.checked)
          .map(item => item.contractModal),
        ...this[MANUFACTURERS_BY_REGION]
          .flatMap(type => type.items)
          .filter(item => item.checked)
          .map(item => item.contractModal),
      ];

      this.$emit('set-trading-manufacturers', uniqBy(result, 'id'));
      this.hideModal();
    },
  },
};
</script>

<style scoped lang="scss">
  @import "~assets/scss/modules/_scroll.scss";

  .ui.modal {
    .ui.button.inmodal {
      margin: 0;
    }
    .ui.checkbox label.medium {
      font-weight: 500;
    }
    .ui.checkbox label:not(.medium) {
      font-size: .6875rem;
      height: auto;
    }
    > .content {
      width: 51rem;

      .flexline {
        display: flex;
        flex-flow: row nowrap;
        justify-content: flex-start;
        align-items: stretch;
        border-bottom: 1px solid #dbe4e9;
      }
      .scroll {
        display: block;
        width: 100%;
        height: 100%;
        overflow: auto;
      }

      .tabular.menu {
        margin-top: 1rem;
        padding: 0 2rem;
        display: flex;
        flex-flow: row nowrap;
        justify-content: flex-start;
        align-items: stretch;
        > .item {
          display: block;
          padding: 1rem 2rem;
          font-size: 0.8125rem;
          line-height: 1;
          font-weight: 500;
          color: #9badb9;
          background-color: #fff;
          border: 1px solid transparent;
          border-top-right-radius: 0.25rem;
          border-top-left-radius: 0.25rem;
          cursor: pointer;
          &.active {
            color: #272727;
            border-color: #dbe4e9;
            pointer-events: none;
            border-bottom-color: transparent;
            margin-bottom: -1px;
          }
        }
      }

      .tab.segment {
        width: 100%;
        height: auto;
        border-bottom: 1px solid #dbe4e9;
        border-top: 1px solid #dbe4e9;
      }

      .block.top {
        display: flex;
        flex-flow: row nowrap;
        justify-content: flex-start;
        align-items: center;
        padding: 0.75rem 2.75rem 0.75rem 2rem;
        border-bottom: 1px solid #dbe4e9;
        .count {
          font-size: 0.8125rem;
          line-height: 1.3;
          font-weight: 400;
          color: #8798a4;
          padding-left: 2rem;
        }
      }

      .block.content {
        display: block;
        width: 100%;
        height: 20.5rem;
      }

      .block.accordion {
        display: block;
        width: 100%;
        height: auto;
        .panel {
          position: relative;
          margin-bottom: 0.5rem;

          &:last-child {
            margin-bottom: 0;
          }
          .content {
            display: none !important;
          }
          &.opened {
            .content {
              display: flex !important;
            }
            .title:after {
              transform: translate(0, -50%) rotate(0);
            }
          }

          .title {
            display: flex;
            flex-flow: row nowrap;
            justify-content: flex-start;
            align-items: center;
            position: relative;
            padding: 0.75rem 4rem 0.75rem 2rem;
            font-size: .8125rem;
            line-height: 1.2;
            font-weight: 500;
            background-color: #ededed;
            cursor: pointer;
            .count {
              font-weight: 400;
              padding-left: 0.25rem;
            }
            &:after {
              content: "";
              width: 1rem;
              height: 0.75rem;
              position: absolute;
              display: block;
              background-size: contain;
              background-repeat: no-repeat;
              background-position: center;
              background-image: url("~assets/svg/arrow/up.svg");
              top: 50%;
              right: 2rem;
              transform: translate(0, -50%) rotate(180deg);
            }
          }

          .content {
            width: 100%;
            flex-flow: column nowrap;
            justify-content: flex-start;
            align-items: flex-start;
            padding: 1rem 2rem 1rem 2rem;
            .ui.checkbox.group {
              margin-bottom: 1rem !important;
            }
          }
        }
      }

      .icon-car {
        display: inline-block;
        vertical-align: middle;
        width: 2rem;
        height: .75rem;
        margin: 0;
        background-repeat: no-repeat;
        background-position: 0;
        &.wagon {
          background-size: 1.1875rem .75rem;
          background-image: url("~assets/svg/type-wagon.svg");
        }
        &.moto {
          background-size: 1.25rem .75rem;
          background-image: url("~assets/svg/type-moto.svg");
        }
        &.car {
          background-size: 1.5rem .75rem;
          background-image: url("~assets/svg/type-car.svg");
        }
      }

      .list {
        display: block;
        width: 100%;
        padding: 1.5rem;
        .item {
          display: flex;
          flex-flow: column nowrap;
          justify-content: flex-start;
          align-items: flex-start;
          padding-bottom: 1rem;
          cursor: pointer;
          .ui.checkbox.master {
            flex: 1 0 100%;
            width: 100%;
            &:after {
              content: '';
              display: block;
              width: 100%;
              height: 1px;
              margin-left: .5rem;
              background-color: #ededed;
            }
          }
          &.all {
            padding-bottom: 1.5rem;
          }
        }
      }

      .list-checkbox {
        display: flex;
        flex-flow: row wrap;
        justify-content: flex-start;
        align-items: flex-start;
        width: 100%;
        max-width: 100%;

        .group {
          display: block;
          width: 100%;
          columns: auto 5;
          column-gap: 0;
          column-fill: balance;
          &.tagged {
            position: relative;
            padding: 0 0.5rem 0.5rem 1.5rem;
          }
          .letter {
            position: absolute;
            left: 0;
            top: 0.625rem;
            font-weight: 500;
            column-span: all;
          }
        }
        .item-checkbox {
          display: inline-block;
          width: 8.5rem;
          break-inside: avoid;
          padding: 0.5rem 0 0 0;
        }
      }
    }
  }
</style>
